# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['MediaManagementArgs', 'MediaManagement']

@pulumi.input_type
class MediaManagementArgs:
    def __init__(__self__, *,
                 auto_rename_folders: pulumi.Input[bool],
                 auto_unmonitor_previously_downloaded_movies: pulumi.Input[bool],
                 chmod_folder: pulumi.Input[str],
                 chown_group: pulumi.Input[str],
                 copy_using_hardlinks: pulumi.Input[bool],
                 create_empty_movie_folders: pulumi.Input[bool],
                 delete_empty_folders: pulumi.Input[bool],
                 download_propers_and_repacks: pulumi.Input[str],
                 enable_media_info: pulumi.Input[bool],
                 extra_file_extensions: pulumi.Input[str],
                 file_date: pulumi.Input[str],
                 import_extra_files: pulumi.Input[bool],
                 minimum_free_space_when_importing: pulumi.Input[int],
                 paths_default_static: pulumi.Input[bool],
                 recycle_bin: pulumi.Input[str],
                 recycle_bin_cleanup_days: pulumi.Input[int],
                 rescan_after_refresh: pulumi.Input[str],
                 set_permissions_linux: pulumi.Input[bool],
                 skip_free_space_check_when_importing: pulumi.Input[bool]):
        """
        The set of arguments for constructing a MediaManagement resource.
        :param pulumi.Input[bool] auto_rename_folders: Auto rename folders.
        :param pulumi.Input[bool] auto_unmonitor_previously_downloaded_movies: Auto unmonitor previously downloaded movies.
        :param pulumi.Input[str] chmod_folder: Permission in linux format.
        :param pulumi.Input[str] chown_group: Group used for permission.
        :param pulumi.Input[bool] copy_using_hardlinks: Use hardlinks instead of copy.
        :param pulumi.Input[bool] create_empty_movie_folders: Create empty movies directories.
        :param pulumi.Input[bool] delete_empty_folders: Delete empty movies directories.
        :param pulumi.Input[str] download_propers_and_repacks: Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        :param pulumi.Input[bool] enable_media_info: Scan files details.
        :param pulumi.Input[str] extra_file_extensions: Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        :param pulumi.Input[str] file_date: Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        :param pulumi.Input[bool] import_extra_files: Import extra files. If enabled it will leverage 'extra*file*extensions'.
        :param pulumi.Input[int] minimum_free_space_when_importing: Minimum free space in MB to allow import.
        :param pulumi.Input[bool] paths_default_static: Path default static.
        :param pulumi.Input[str] recycle_bin: Recycle bin absolute path.
        :param pulumi.Input[int] recycle_bin_cleanup_days: Recyle bin days of retention.
        :param pulumi.Input[str] rescan_after_refresh: Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        :param pulumi.Input[bool] set_permissions_linux: Set permission for imported files.
        :param pulumi.Input[bool] skip_free_space_check_when_importing: Skip free space check before importing.
        """
        pulumi.set(__self__, "auto_rename_folders", auto_rename_folders)
        pulumi.set(__self__, "auto_unmonitor_previously_downloaded_movies", auto_unmonitor_previously_downloaded_movies)
        pulumi.set(__self__, "chmod_folder", chmod_folder)
        pulumi.set(__self__, "chown_group", chown_group)
        pulumi.set(__self__, "copy_using_hardlinks", copy_using_hardlinks)
        pulumi.set(__self__, "create_empty_movie_folders", create_empty_movie_folders)
        pulumi.set(__self__, "delete_empty_folders", delete_empty_folders)
        pulumi.set(__self__, "download_propers_and_repacks", download_propers_and_repacks)
        pulumi.set(__self__, "enable_media_info", enable_media_info)
        pulumi.set(__self__, "extra_file_extensions", extra_file_extensions)
        pulumi.set(__self__, "file_date", file_date)
        pulumi.set(__self__, "import_extra_files", import_extra_files)
        pulumi.set(__self__, "minimum_free_space_when_importing", minimum_free_space_when_importing)
        pulumi.set(__self__, "paths_default_static", paths_default_static)
        pulumi.set(__self__, "recycle_bin", recycle_bin)
        pulumi.set(__self__, "recycle_bin_cleanup_days", recycle_bin_cleanup_days)
        pulumi.set(__self__, "rescan_after_refresh", rescan_after_refresh)
        pulumi.set(__self__, "set_permissions_linux", set_permissions_linux)
        pulumi.set(__self__, "skip_free_space_check_when_importing", skip_free_space_check_when_importing)

    @property
    @pulumi.getter(name="autoRenameFolders")
    def auto_rename_folders(self) -> pulumi.Input[bool]:
        """
        Auto rename folders.
        """
        return pulumi.get(self, "auto_rename_folders")

    @auto_rename_folders.setter
    def auto_rename_folders(self, value: pulumi.Input[bool]):
        pulumi.set(self, "auto_rename_folders", value)

    @property
    @pulumi.getter(name="autoUnmonitorPreviouslyDownloadedMovies")
    def auto_unmonitor_previously_downloaded_movies(self) -> pulumi.Input[bool]:
        """
        Auto unmonitor previously downloaded movies.
        """
        return pulumi.get(self, "auto_unmonitor_previously_downloaded_movies")

    @auto_unmonitor_previously_downloaded_movies.setter
    def auto_unmonitor_previously_downloaded_movies(self, value: pulumi.Input[bool]):
        pulumi.set(self, "auto_unmonitor_previously_downloaded_movies", value)

    @property
    @pulumi.getter(name="chmodFolder")
    def chmod_folder(self) -> pulumi.Input[str]:
        """
        Permission in linux format.
        """
        return pulumi.get(self, "chmod_folder")

    @chmod_folder.setter
    def chmod_folder(self, value: pulumi.Input[str]):
        pulumi.set(self, "chmod_folder", value)

    @property
    @pulumi.getter(name="chownGroup")
    def chown_group(self) -> pulumi.Input[str]:
        """
        Group used for permission.
        """
        return pulumi.get(self, "chown_group")

    @chown_group.setter
    def chown_group(self, value: pulumi.Input[str]):
        pulumi.set(self, "chown_group", value)

    @property
    @pulumi.getter(name="copyUsingHardlinks")
    def copy_using_hardlinks(self) -> pulumi.Input[bool]:
        """
        Use hardlinks instead of copy.
        """
        return pulumi.get(self, "copy_using_hardlinks")

    @copy_using_hardlinks.setter
    def copy_using_hardlinks(self, value: pulumi.Input[bool]):
        pulumi.set(self, "copy_using_hardlinks", value)

    @property
    @pulumi.getter(name="createEmptyMovieFolders")
    def create_empty_movie_folders(self) -> pulumi.Input[bool]:
        """
        Create empty movies directories.
        """
        return pulumi.get(self, "create_empty_movie_folders")

    @create_empty_movie_folders.setter
    def create_empty_movie_folders(self, value: pulumi.Input[bool]):
        pulumi.set(self, "create_empty_movie_folders", value)

    @property
    @pulumi.getter(name="deleteEmptyFolders")
    def delete_empty_folders(self) -> pulumi.Input[bool]:
        """
        Delete empty movies directories.
        """
        return pulumi.get(self, "delete_empty_folders")

    @delete_empty_folders.setter
    def delete_empty_folders(self, value: pulumi.Input[bool]):
        pulumi.set(self, "delete_empty_folders", value)

    @property
    @pulumi.getter(name="downloadPropersAndRepacks")
    def download_propers_and_repacks(self) -> pulumi.Input[str]:
        """
        Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        """
        return pulumi.get(self, "download_propers_and_repacks")

    @download_propers_and_repacks.setter
    def download_propers_and_repacks(self, value: pulumi.Input[str]):
        pulumi.set(self, "download_propers_and_repacks", value)

    @property
    @pulumi.getter(name="enableMediaInfo")
    def enable_media_info(self) -> pulumi.Input[bool]:
        """
        Scan files details.
        """
        return pulumi.get(self, "enable_media_info")

    @enable_media_info.setter
    def enable_media_info(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enable_media_info", value)

    @property
    @pulumi.getter(name="extraFileExtensions")
    def extra_file_extensions(self) -> pulumi.Input[str]:
        """
        Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        """
        return pulumi.get(self, "extra_file_extensions")

    @extra_file_extensions.setter
    def extra_file_extensions(self, value: pulumi.Input[str]):
        pulumi.set(self, "extra_file_extensions", value)

    @property
    @pulumi.getter(name="fileDate")
    def file_date(self) -> pulumi.Input[str]:
        """
        Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        """
        return pulumi.get(self, "file_date")

    @file_date.setter
    def file_date(self, value: pulumi.Input[str]):
        pulumi.set(self, "file_date", value)

    @property
    @pulumi.getter(name="importExtraFiles")
    def import_extra_files(self) -> pulumi.Input[bool]:
        """
        Import extra files. If enabled it will leverage 'extra*file*extensions'.
        """
        return pulumi.get(self, "import_extra_files")

    @import_extra_files.setter
    def import_extra_files(self, value: pulumi.Input[bool]):
        pulumi.set(self, "import_extra_files", value)

    @property
    @pulumi.getter(name="minimumFreeSpaceWhenImporting")
    def minimum_free_space_when_importing(self) -> pulumi.Input[int]:
        """
        Minimum free space in MB to allow import.
        """
        return pulumi.get(self, "minimum_free_space_when_importing")

    @minimum_free_space_when_importing.setter
    def minimum_free_space_when_importing(self, value: pulumi.Input[int]):
        pulumi.set(self, "minimum_free_space_when_importing", value)

    @property
    @pulumi.getter(name="pathsDefaultStatic")
    def paths_default_static(self) -> pulumi.Input[bool]:
        """
        Path default static.
        """
        return pulumi.get(self, "paths_default_static")

    @paths_default_static.setter
    def paths_default_static(self, value: pulumi.Input[bool]):
        pulumi.set(self, "paths_default_static", value)

    @property
    @pulumi.getter(name="recycleBin")
    def recycle_bin(self) -> pulumi.Input[str]:
        """
        Recycle bin absolute path.
        """
        return pulumi.get(self, "recycle_bin")

    @recycle_bin.setter
    def recycle_bin(self, value: pulumi.Input[str]):
        pulumi.set(self, "recycle_bin", value)

    @property
    @pulumi.getter(name="recycleBinCleanupDays")
    def recycle_bin_cleanup_days(self) -> pulumi.Input[int]:
        """
        Recyle bin days of retention.
        """
        return pulumi.get(self, "recycle_bin_cleanup_days")

    @recycle_bin_cleanup_days.setter
    def recycle_bin_cleanup_days(self, value: pulumi.Input[int]):
        pulumi.set(self, "recycle_bin_cleanup_days", value)

    @property
    @pulumi.getter(name="rescanAfterRefresh")
    def rescan_after_refresh(self) -> pulumi.Input[str]:
        """
        Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        """
        return pulumi.get(self, "rescan_after_refresh")

    @rescan_after_refresh.setter
    def rescan_after_refresh(self, value: pulumi.Input[str]):
        pulumi.set(self, "rescan_after_refresh", value)

    @property
    @pulumi.getter(name="setPermissionsLinux")
    def set_permissions_linux(self) -> pulumi.Input[bool]:
        """
        Set permission for imported files.
        """
        return pulumi.get(self, "set_permissions_linux")

    @set_permissions_linux.setter
    def set_permissions_linux(self, value: pulumi.Input[bool]):
        pulumi.set(self, "set_permissions_linux", value)

    @property
    @pulumi.getter(name="skipFreeSpaceCheckWhenImporting")
    def skip_free_space_check_when_importing(self) -> pulumi.Input[bool]:
        """
        Skip free space check before importing.
        """
        return pulumi.get(self, "skip_free_space_check_when_importing")

    @skip_free_space_check_when_importing.setter
    def skip_free_space_check_when_importing(self, value: pulumi.Input[bool]):
        pulumi.set(self, "skip_free_space_check_when_importing", value)


@pulumi.input_type
class _MediaManagementState:
    def __init__(__self__, *,
                 auto_rename_folders: Optional[pulumi.Input[bool]] = None,
                 auto_unmonitor_previously_downloaded_movies: Optional[pulumi.Input[bool]] = None,
                 chmod_folder: Optional[pulumi.Input[str]] = None,
                 chown_group: Optional[pulumi.Input[str]] = None,
                 copy_using_hardlinks: Optional[pulumi.Input[bool]] = None,
                 create_empty_movie_folders: Optional[pulumi.Input[bool]] = None,
                 delete_empty_folders: Optional[pulumi.Input[bool]] = None,
                 download_propers_and_repacks: Optional[pulumi.Input[str]] = None,
                 enable_media_info: Optional[pulumi.Input[bool]] = None,
                 extra_file_extensions: Optional[pulumi.Input[str]] = None,
                 file_date: Optional[pulumi.Input[str]] = None,
                 import_extra_files: Optional[pulumi.Input[bool]] = None,
                 minimum_free_space_when_importing: Optional[pulumi.Input[int]] = None,
                 paths_default_static: Optional[pulumi.Input[bool]] = None,
                 recycle_bin: Optional[pulumi.Input[str]] = None,
                 recycle_bin_cleanup_days: Optional[pulumi.Input[int]] = None,
                 rescan_after_refresh: Optional[pulumi.Input[str]] = None,
                 set_permissions_linux: Optional[pulumi.Input[bool]] = None,
                 skip_free_space_check_when_importing: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering MediaManagement resources.
        :param pulumi.Input[bool] auto_rename_folders: Auto rename folders.
        :param pulumi.Input[bool] auto_unmonitor_previously_downloaded_movies: Auto unmonitor previously downloaded movies.
        :param pulumi.Input[str] chmod_folder: Permission in linux format.
        :param pulumi.Input[str] chown_group: Group used for permission.
        :param pulumi.Input[bool] copy_using_hardlinks: Use hardlinks instead of copy.
        :param pulumi.Input[bool] create_empty_movie_folders: Create empty movies directories.
        :param pulumi.Input[bool] delete_empty_folders: Delete empty movies directories.
        :param pulumi.Input[str] download_propers_and_repacks: Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        :param pulumi.Input[bool] enable_media_info: Scan files details.
        :param pulumi.Input[str] extra_file_extensions: Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        :param pulumi.Input[str] file_date: Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        :param pulumi.Input[bool] import_extra_files: Import extra files. If enabled it will leverage 'extra*file*extensions'.
        :param pulumi.Input[int] minimum_free_space_when_importing: Minimum free space in MB to allow import.
        :param pulumi.Input[bool] paths_default_static: Path default static.
        :param pulumi.Input[str] recycle_bin: Recycle bin absolute path.
        :param pulumi.Input[int] recycle_bin_cleanup_days: Recyle bin days of retention.
        :param pulumi.Input[str] rescan_after_refresh: Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        :param pulumi.Input[bool] set_permissions_linux: Set permission for imported files.
        :param pulumi.Input[bool] skip_free_space_check_when_importing: Skip free space check before importing.
        """
        if auto_rename_folders is not None:
            pulumi.set(__self__, "auto_rename_folders", auto_rename_folders)
        if auto_unmonitor_previously_downloaded_movies is not None:
            pulumi.set(__self__, "auto_unmonitor_previously_downloaded_movies", auto_unmonitor_previously_downloaded_movies)
        if chmod_folder is not None:
            pulumi.set(__self__, "chmod_folder", chmod_folder)
        if chown_group is not None:
            pulumi.set(__self__, "chown_group", chown_group)
        if copy_using_hardlinks is not None:
            pulumi.set(__self__, "copy_using_hardlinks", copy_using_hardlinks)
        if create_empty_movie_folders is not None:
            pulumi.set(__self__, "create_empty_movie_folders", create_empty_movie_folders)
        if delete_empty_folders is not None:
            pulumi.set(__self__, "delete_empty_folders", delete_empty_folders)
        if download_propers_and_repacks is not None:
            pulumi.set(__self__, "download_propers_and_repacks", download_propers_and_repacks)
        if enable_media_info is not None:
            pulumi.set(__self__, "enable_media_info", enable_media_info)
        if extra_file_extensions is not None:
            pulumi.set(__self__, "extra_file_extensions", extra_file_extensions)
        if file_date is not None:
            pulumi.set(__self__, "file_date", file_date)
        if import_extra_files is not None:
            pulumi.set(__self__, "import_extra_files", import_extra_files)
        if minimum_free_space_when_importing is not None:
            pulumi.set(__self__, "minimum_free_space_when_importing", minimum_free_space_when_importing)
        if paths_default_static is not None:
            pulumi.set(__self__, "paths_default_static", paths_default_static)
        if recycle_bin is not None:
            pulumi.set(__self__, "recycle_bin", recycle_bin)
        if recycle_bin_cleanup_days is not None:
            pulumi.set(__self__, "recycle_bin_cleanup_days", recycle_bin_cleanup_days)
        if rescan_after_refresh is not None:
            pulumi.set(__self__, "rescan_after_refresh", rescan_after_refresh)
        if set_permissions_linux is not None:
            pulumi.set(__self__, "set_permissions_linux", set_permissions_linux)
        if skip_free_space_check_when_importing is not None:
            pulumi.set(__self__, "skip_free_space_check_when_importing", skip_free_space_check_when_importing)

    @property
    @pulumi.getter(name="autoRenameFolders")
    def auto_rename_folders(self) -> Optional[pulumi.Input[bool]]:
        """
        Auto rename folders.
        """
        return pulumi.get(self, "auto_rename_folders")

    @auto_rename_folders.setter
    def auto_rename_folders(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "auto_rename_folders", value)

    @property
    @pulumi.getter(name="autoUnmonitorPreviouslyDownloadedMovies")
    def auto_unmonitor_previously_downloaded_movies(self) -> Optional[pulumi.Input[bool]]:
        """
        Auto unmonitor previously downloaded movies.
        """
        return pulumi.get(self, "auto_unmonitor_previously_downloaded_movies")

    @auto_unmonitor_previously_downloaded_movies.setter
    def auto_unmonitor_previously_downloaded_movies(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "auto_unmonitor_previously_downloaded_movies", value)

    @property
    @pulumi.getter(name="chmodFolder")
    def chmod_folder(self) -> Optional[pulumi.Input[str]]:
        """
        Permission in linux format.
        """
        return pulumi.get(self, "chmod_folder")

    @chmod_folder.setter
    def chmod_folder(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "chmod_folder", value)

    @property
    @pulumi.getter(name="chownGroup")
    def chown_group(self) -> Optional[pulumi.Input[str]]:
        """
        Group used for permission.
        """
        return pulumi.get(self, "chown_group")

    @chown_group.setter
    def chown_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "chown_group", value)

    @property
    @pulumi.getter(name="copyUsingHardlinks")
    def copy_using_hardlinks(self) -> Optional[pulumi.Input[bool]]:
        """
        Use hardlinks instead of copy.
        """
        return pulumi.get(self, "copy_using_hardlinks")

    @copy_using_hardlinks.setter
    def copy_using_hardlinks(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "copy_using_hardlinks", value)

    @property
    @pulumi.getter(name="createEmptyMovieFolders")
    def create_empty_movie_folders(self) -> Optional[pulumi.Input[bool]]:
        """
        Create empty movies directories.
        """
        return pulumi.get(self, "create_empty_movie_folders")

    @create_empty_movie_folders.setter
    def create_empty_movie_folders(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "create_empty_movie_folders", value)

    @property
    @pulumi.getter(name="deleteEmptyFolders")
    def delete_empty_folders(self) -> Optional[pulumi.Input[bool]]:
        """
        Delete empty movies directories.
        """
        return pulumi.get(self, "delete_empty_folders")

    @delete_empty_folders.setter
    def delete_empty_folders(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_empty_folders", value)

    @property
    @pulumi.getter(name="downloadPropersAndRepacks")
    def download_propers_and_repacks(self) -> Optional[pulumi.Input[str]]:
        """
        Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        """
        return pulumi.get(self, "download_propers_and_repacks")

    @download_propers_and_repacks.setter
    def download_propers_and_repacks(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "download_propers_and_repacks", value)

    @property
    @pulumi.getter(name="enableMediaInfo")
    def enable_media_info(self) -> Optional[pulumi.Input[bool]]:
        """
        Scan files details.
        """
        return pulumi.get(self, "enable_media_info")

    @enable_media_info.setter
    def enable_media_info(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_media_info", value)

    @property
    @pulumi.getter(name="extraFileExtensions")
    def extra_file_extensions(self) -> Optional[pulumi.Input[str]]:
        """
        Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        """
        return pulumi.get(self, "extra_file_extensions")

    @extra_file_extensions.setter
    def extra_file_extensions(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "extra_file_extensions", value)

    @property
    @pulumi.getter(name="fileDate")
    def file_date(self) -> Optional[pulumi.Input[str]]:
        """
        Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        """
        return pulumi.get(self, "file_date")

    @file_date.setter
    def file_date(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_date", value)

    @property
    @pulumi.getter(name="importExtraFiles")
    def import_extra_files(self) -> Optional[pulumi.Input[bool]]:
        """
        Import extra files. If enabled it will leverage 'extra*file*extensions'.
        """
        return pulumi.get(self, "import_extra_files")

    @import_extra_files.setter
    def import_extra_files(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "import_extra_files", value)

    @property
    @pulumi.getter(name="minimumFreeSpaceWhenImporting")
    def minimum_free_space_when_importing(self) -> Optional[pulumi.Input[int]]:
        """
        Minimum free space in MB to allow import.
        """
        return pulumi.get(self, "minimum_free_space_when_importing")

    @minimum_free_space_when_importing.setter
    def minimum_free_space_when_importing(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "minimum_free_space_when_importing", value)

    @property
    @pulumi.getter(name="pathsDefaultStatic")
    def paths_default_static(self) -> Optional[pulumi.Input[bool]]:
        """
        Path default static.
        """
        return pulumi.get(self, "paths_default_static")

    @paths_default_static.setter
    def paths_default_static(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "paths_default_static", value)

    @property
    @pulumi.getter(name="recycleBin")
    def recycle_bin(self) -> Optional[pulumi.Input[str]]:
        """
        Recycle bin absolute path.
        """
        return pulumi.get(self, "recycle_bin")

    @recycle_bin.setter
    def recycle_bin(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "recycle_bin", value)

    @property
    @pulumi.getter(name="recycleBinCleanupDays")
    def recycle_bin_cleanup_days(self) -> Optional[pulumi.Input[int]]:
        """
        Recyle bin days of retention.
        """
        return pulumi.get(self, "recycle_bin_cleanup_days")

    @recycle_bin_cleanup_days.setter
    def recycle_bin_cleanup_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "recycle_bin_cleanup_days", value)

    @property
    @pulumi.getter(name="rescanAfterRefresh")
    def rescan_after_refresh(self) -> Optional[pulumi.Input[str]]:
        """
        Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        """
        return pulumi.get(self, "rescan_after_refresh")

    @rescan_after_refresh.setter
    def rescan_after_refresh(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rescan_after_refresh", value)

    @property
    @pulumi.getter(name="setPermissionsLinux")
    def set_permissions_linux(self) -> Optional[pulumi.Input[bool]]:
        """
        Set permission for imported files.
        """
        return pulumi.get(self, "set_permissions_linux")

    @set_permissions_linux.setter
    def set_permissions_linux(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "set_permissions_linux", value)

    @property
    @pulumi.getter(name="skipFreeSpaceCheckWhenImporting")
    def skip_free_space_check_when_importing(self) -> Optional[pulumi.Input[bool]]:
        """
        Skip free space check before importing.
        """
        return pulumi.get(self, "skip_free_space_check_when_importing")

    @skip_free_space_check_when_importing.setter
    def skip_free_space_check_when_importing(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "skip_free_space_check_when_importing", value)


class MediaManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_rename_folders: Optional[pulumi.Input[bool]] = None,
                 auto_unmonitor_previously_downloaded_movies: Optional[pulumi.Input[bool]] = None,
                 chmod_folder: Optional[pulumi.Input[str]] = None,
                 chown_group: Optional[pulumi.Input[str]] = None,
                 copy_using_hardlinks: Optional[pulumi.Input[bool]] = None,
                 create_empty_movie_folders: Optional[pulumi.Input[bool]] = None,
                 delete_empty_folders: Optional[pulumi.Input[bool]] = None,
                 download_propers_and_repacks: Optional[pulumi.Input[str]] = None,
                 enable_media_info: Optional[pulumi.Input[bool]] = None,
                 extra_file_extensions: Optional[pulumi.Input[str]] = None,
                 file_date: Optional[pulumi.Input[str]] = None,
                 import_extra_files: Optional[pulumi.Input[bool]] = None,
                 minimum_free_space_when_importing: Optional[pulumi.Input[int]] = None,
                 paths_default_static: Optional[pulumi.Input[bool]] = None,
                 recycle_bin: Optional[pulumi.Input[str]] = None,
                 recycle_bin_cleanup_days: Optional[pulumi.Input[int]] = None,
                 rescan_after_refresh: Optional[pulumi.Input[str]] = None,
                 set_permissions_linux: Optional[pulumi.Input[bool]] = None,
                 skip_free_space_check_when_importing: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        <!-- subcategory:Media Management -->
        Media Management resource.
        For more information refer to [Naming](https://wiki.servarr.com/radarr/settings#file-management) documentation.

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import radarr:MediaManagement/mediaManagement:MediaManagement example ""
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_rename_folders: Auto rename folders.
        :param pulumi.Input[bool] auto_unmonitor_previously_downloaded_movies: Auto unmonitor previously downloaded movies.
        :param pulumi.Input[str] chmod_folder: Permission in linux format.
        :param pulumi.Input[str] chown_group: Group used for permission.
        :param pulumi.Input[bool] copy_using_hardlinks: Use hardlinks instead of copy.
        :param pulumi.Input[bool] create_empty_movie_folders: Create empty movies directories.
        :param pulumi.Input[bool] delete_empty_folders: Delete empty movies directories.
        :param pulumi.Input[str] download_propers_and_repacks: Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        :param pulumi.Input[bool] enable_media_info: Scan files details.
        :param pulumi.Input[str] extra_file_extensions: Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        :param pulumi.Input[str] file_date: Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        :param pulumi.Input[bool] import_extra_files: Import extra files. If enabled it will leverage 'extra*file*extensions'.
        :param pulumi.Input[int] minimum_free_space_when_importing: Minimum free space in MB to allow import.
        :param pulumi.Input[bool] paths_default_static: Path default static.
        :param pulumi.Input[str] recycle_bin: Recycle bin absolute path.
        :param pulumi.Input[int] recycle_bin_cleanup_days: Recyle bin days of retention.
        :param pulumi.Input[str] rescan_after_refresh: Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        :param pulumi.Input[bool] set_permissions_linux: Set permission for imported files.
        :param pulumi.Input[bool] skip_free_space_check_when_importing: Skip free space check before importing.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MediaManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Media Management -->
        Media Management resource.
        For more information refer to [Naming](https://wiki.servarr.com/radarr/settings#file-management) documentation.

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import radarr:MediaManagement/mediaManagement:MediaManagement example ""
        ```

        :param str resource_name: The name of the resource.
        :param MediaManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MediaManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_rename_folders: Optional[pulumi.Input[bool]] = None,
                 auto_unmonitor_previously_downloaded_movies: Optional[pulumi.Input[bool]] = None,
                 chmod_folder: Optional[pulumi.Input[str]] = None,
                 chown_group: Optional[pulumi.Input[str]] = None,
                 copy_using_hardlinks: Optional[pulumi.Input[bool]] = None,
                 create_empty_movie_folders: Optional[pulumi.Input[bool]] = None,
                 delete_empty_folders: Optional[pulumi.Input[bool]] = None,
                 download_propers_and_repacks: Optional[pulumi.Input[str]] = None,
                 enable_media_info: Optional[pulumi.Input[bool]] = None,
                 extra_file_extensions: Optional[pulumi.Input[str]] = None,
                 file_date: Optional[pulumi.Input[str]] = None,
                 import_extra_files: Optional[pulumi.Input[bool]] = None,
                 minimum_free_space_when_importing: Optional[pulumi.Input[int]] = None,
                 paths_default_static: Optional[pulumi.Input[bool]] = None,
                 recycle_bin: Optional[pulumi.Input[str]] = None,
                 recycle_bin_cleanup_days: Optional[pulumi.Input[int]] = None,
                 rescan_after_refresh: Optional[pulumi.Input[str]] = None,
                 set_permissions_linux: Optional[pulumi.Input[bool]] = None,
                 skip_free_space_check_when_importing: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MediaManagementArgs.__new__(MediaManagementArgs)

            if auto_rename_folders is None and not opts.urn:
                raise TypeError("Missing required property 'auto_rename_folders'")
            __props__.__dict__["auto_rename_folders"] = auto_rename_folders
            if auto_unmonitor_previously_downloaded_movies is None and not opts.urn:
                raise TypeError("Missing required property 'auto_unmonitor_previously_downloaded_movies'")
            __props__.__dict__["auto_unmonitor_previously_downloaded_movies"] = auto_unmonitor_previously_downloaded_movies
            if chmod_folder is None and not opts.urn:
                raise TypeError("Missing required property 'chmod_folder'")
            __props__.__dict__["chmod_folder"] = chmod_folder
            if chown_group is None and not opts.urn:
                raise TypeError("Missing required property 'chown_group'")
            __props__.__dict__["chown_group"] = chown_group
            if copy_using_hardlinks is None and not opts.urn:
                raise TypeError("Missing required property 'copy_using_hardlinks'")
            __props__.__dict__["copy_using_hardlinks"] = copy_using_hardlinks
            if create_empty_movie_folders is None and not opts.urn:
                raise TypeError("Missing required property 'create_empty_movie_folders'")
            __props__.__dict__["create_empty_movie_folders"] = create_empty_movie_folders
            if delete_empty_folders is None and not opts.urn:
                raise TypeError("Missing required property 'delete_empty_folders'")
            __props__.__dict__["delete_empty_folders"] = delete_empty_folders
            if download_propers_and_repacks is None and not opts.urn:
                raise TypeError("Missing required property 'download_propers_and_repacks'")
            __props__.__dict__["download_propers_and_repacks"] = download_propers_and_repacks
            if enable_media_info is None and not opts.urn:
                raise TypeError("Missing required property 'enable_media_info'")
            __props__.__dict__["enable_media_info"] = enable_media_info
            if extra_file_extensions is None and not opts.urn:
                raise TypeError("Missing required property 'extra_file_extensions'")
            __props__.__dict__["extra_file_extensions"] = extra_file_extensions
            if file_date is None and not opts.urn:
                raise TypeError("Missing required property 'file_date'")
            __props__.__dict__["file_date"] = file_date
            if import_extra_files is None and not opts.urn:
                raise TypeError("Missing required property 'import_extra_files'")
            __props__.__dict__["import_extra_files"] = import_extra_files
            if minimum_free_space_when_importing is None and not opts.urn:
                raise TypeError("Missing required property 'minimum_free_space_when_importing'")
            __props__.__dict__["minimum_free_space_when_importing"] = minimum_free_space_when_importing
            if paths_default_static is None and not opts.urn:
                raise TypeError("Missing required property 'paths_default_static'")
            __props__.__dict__["paths_default_static"] = paths_default_static
            if recycle_bin is None and not opts.urn:
                raise TypeError("Missing required property 'recycle_bin'")
            __props__.__dict__["recycle_bin"] = recycle_bin
            if recycle_bin_cleanup_days is None and not opts.urn:
                raise TypeError("Missing required property 'recycle_bin_cleanup_days'")
            __props__.__dict__["recycle_bin_cleanup_days"] = recycle_bin_cleanup_days
            if rescan_after_refresh is None and not opts.urn:
                raise TypeError("Missing required property 'rescan_after_refresh'")
            __props__.__dict__["rescan_after_refresh"] = rescan_after_refresh
            if set_permissions_linux is None and not opts.urn:
                raise TypeError("Missing required property 'set_permissions_linux'")
            __props__.__dict__["set_permissions_linux"] = set_permissions_linux
            if skip_free_space_check_when_importing is None and not opts.urn:
                raise TypeError("Missing required property 'skip_free_space_check_when_importing'")
            __props__.__dict__["skip_free_space_check_when_importing"] = skip_free_space_check_when_importing
        super(MediaManagement, __self__).__init__(
            'radarr:MediaManagement/mediaManagement:MediaManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            auto_rename_folders: Optional[pulumi.Input[bool]] = None,
            auto_unmonitor_previously_downloaded_movies: Optional[pulumi.Input[bool]] = None,
            chmod_folder: Optional[pulumi.Input[str]] = None,
            chown_group: Optional[pulumi.Input[str]] = None,
            copy_using_hardlinks: Optional[pulumi.Input[bool]] = None,
            create_empty_movie_folders: Optional[pulumi.Input[bool]] = None,
            delete_empty_folders: Optional[pulumi.Input[bool]] = None,
            download_propers_and_repacks: Optional[pulumi.Input[str]] = None,
            enable_media_info: Optional[pulumi.Input[bool]] = None,
            extra_file_extensions: Optional[pulumi.Input[str]] = None,
            file_date: Optional[pulumi.Input[str]] = None,
            import_extra_files: Optional[pulumi.Input[bool]] = None,
            minimum_free_space_when_importing: Optional[pulumi.Input[int]] = None,
            paths_default_static: Optional[pulumi.Input[bool]] = None,
            recycle_bin: Optional[pulumi.Input[str]] = None,
            recycle_bin_cleanup_days: Optional[pulumi.Input[int]] = None,
            rescan_after_refresh: Optional[pulumi.Input[str]] = None,
            set_permissions_linux: Optional[pulumi.Input[bool]] = None,
            skip_free_space_check_when_importing: Optional[pulumi.Input[bool]] = None) -> 'MediaManagement':
        """
        Get an existing MediaManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_rename_folders: Auto rename folders.
        :param pulumi.Input[bool] auto_unmonitor_previously_downloaded_movies: Auto unmonitor previously downloaded movies.
        :param pulumi.Input[str] chmod_folder: Permission in linux format.
        :param pulumi.Input[str] chown_group: Group used for permission.
        :param pulumi.Input[bool] copy_using_hardlinks: Use hardlinks instead of copy.
        :param pulumi.Input[bool] create_empty_movie_folders: Create empty movies directories.
        :param pulumi.Input[bool] delete_empty_folders: Delete empty movies directories.
        :param pulumi.Input[str] download_propers_and_repacks: Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        :param pulumi.Input[bool] enable_media_info: Scan files details.
        :param pulumi.Input[str] extra_file_extensions: Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        :param pulumi.Input[str] file_date: Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        :param pulumi.Input[bool] import_extra_files: Import extra files. If enabled it will leverage 'extra*file*extensions'.
        :param pulumi.Input[int] minimum_free_space_when_importing: Minimum free space in MB to allow import.
        :param pulumi.Input[bool] paths_default_static: Path default static.
        :param pulumi.Input[str] recycle_bin: Recycle bin absolute path.
        :param pulumi.Input[int] recycle_bin_cleanup_days: Recyle bin days of retention.
        :param pulumi.Input[str] rescan_after_refresh: Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        :param pulumi.Input[bool] set_permissions_linux: Set permission for imported files.
        :param pulumi.Input[bool] skip_free_space_check_when_importing: Skip free space check before importing.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MediaManagementState.__new__(_MediaManagementState)

        __props__.__dict__["auto_rename_folders"] = auto_rename_folders
        __props__.__dict__["auto_unmonitor_previously_downloaded_movies"] = auto_unmonitor_previously_downloaded_movies
        __props__.__dict__["chmod_folder"] = chmod_folder
        __props__.__dict__["chown_group"] = chown_group
        __props__.__dict__["copy_using_hardlinks"] = copy_using_hardlinks
        __props__.__dict__["create_empty_movie_folders"] = create_empty_movie_folders
        __props__.__dict__["delete_empty_folders"] = delete_empty_folders
        __props__.__dict__["download_propers_and_repacks"] = download_propers_and_repacks
        __props__.__dict__["enable_media_info"] = enable_media_info
        __props__.__dict__["extra_file_extensions"] = extra_file_extensions
        __props__.__dict__["file_date"] = file_date
        __props__.__dict__["import_extra_files"] = import_extra_files
        __props__.__dict__["minimum_free_space_when_importing"] = minimum_free_space_when_importing
        __props__.__dict__["paths_default_static"] = paths_default_static
        __props__.__dict__["recycle_bin"] = recycle_bin
        __props__.__dict__["recycle_bin_cleanup_days"] = recycle_bin_cleanup_days
        __props__.__dict__["rescan_after_refresh"] = rescan_after_refresh
        __props__.__dict__["set_permissions_linux"] = set_permissions_linux
        __props__.__dict__["skip_free_space_check_when_importing"] = skip_free_space_check_when_importing
        return MediaManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoRenameFolders")
    def auto_rename_folders(self) -> pulumi.Output[bool]:
        """
        Auto rename folders.
        """
        return pulumi.get(self, "auto_rename_folders")

    @property
    @pulumi.getter(name="autoUnmonitorPreviouslyDownloadedMovies")
    def auto_unmonitor_previously_downloaded_movies(self) -> pulumi.Output[bool]:
        """
        Auto unmonitor previously downloaded movies.
        """
        return pulumi.get(self, "auto_unmonitor_previously_downloaded_movies")

    @property
    @pulumi.getter(name="chmodFolder")
    def chmod_folder(self) -> pulumi.Output[str]:
        """
        Permission in linux format.
        """
        return pulumi.get(self, "chmod_folder")

    @property
    @pulumi.getter(name="chownGroup")
    def chown_group(self) -> pulumi.Output[str]:
        """
        Group used for permission.
        """
        return pulumi.get(self, "chown_group")

    @property
    @pulumi.getter(name="copyUsingHardlinks")
    def copy_using_hardlinks(self) -> pulumi.Output[bool]:
        """
        Use hardlinks instead of copy.
        """
        return pulumi.get(self, "copy_using_hardlinks")

    @property
    @pulumi.getter(name="createEmptyMovieFolders")
    def create_empty_movie_folders(self) -> pulumi.Output[bool]:
        """
        Create empty movies directories.
        """
        return pulumi.get(self, "create_empty_movie_folders")

    @property
    @pulumi.getter(name="deleteEmptyFolders")
    def delete_empty_folders(self) -> pulumi.Output[bool]:
        """
        Delete empty movies directories.
        """
        return pulumi.get(self, "delete_empty_folders")

    @property
    @pulumi.getter(name="downloadPropersAndRepacks")
    def download_propers_and_repacks(self) -> pulumi.Output[str]:
        """
        Download proper and repack policy. valid inputs are: 'preferAndUpgrade', 'doNotUpgrade', and 'doNotPrefer'.
        """
        return pulumi.get(self, "download_propers_and_repacks")

    @property
    @pulumi.getter(name="enableMediaInfo")
    def enable_media_info(self) -> pulumi.Output[bool]:
        """
        Scan files details.
        """
        return pulumi.get(self, "enable_media_info")

    @property
    @pulumi.getter(name="extraFileExtensions")
    def extra_file_extensions(self) -> pulumi.Output[str]:
        """
        Comma separated list of extra files to import (.nfo will be imported as .nfo-orig).
        """
        return pulumi.get(self, "extra_file_extensions")

    @property
    @pulumi.getter(name="fileDate")
    def file_date(self) -> pulumi.Output[str]:
        """
        Define the file date modification. valid inputs are: 'none', 'cinemas, and 'release'.
        """
        return pulumi.get(self, "file_date")

    @property
    @pulumi.getter(name="importExtraFiles")
    def import_extra_files(self) -> pulumi.Output[bool]:
        """
        Import extra files. If enabled it will leverage 'extra*file*extensions'.
        """
        return pulumi.get(self, "import_extra_files")

    @property
    @pulumi.getter(name="minimumFreeSpaceWhenImporting")
    def minimum_free_space_when_importing(self) -> pulumi.Output[int]:
        """
        Minimum free space in MB to allow import.
        """
        return pulumi.get(self, "minimum_free_space_when_importing")

    @property
    @pulumi.getter(name="pathsDefaultStatic")
    def paths_default_static(self) -> pulumi.Output[bool]:
        """
        Path default static.
        """
        return pulumi.get(self, "paths_default_static")

    @property
    @pulumi.getter(name="recycleBin")
    def recycle_bin(self) -> pulumi.Output[str]:
        """
        Recycle bin absolute path.
        """
        return pulumi.get(self, "recycle_bin")

    @property
    @pulumi.getter(name="recycleBinCleanupDays")
    def recycle_bin_cleanup_days(self) -> pulumi.Output[int]:
        """
        Recyle bin days of retention.
        """
        return pulumi.get(self, "recycle_bin_cleanup_days")

    @property
    @pulumi.getter(name="rescanAfterRefresh")
    def rescan_after_refresh(self) -> pulumi.Output[str]:
        """
        Rescan after refresh policy. valid inputs are: 'always', 'afterManual' and 'never'.
        """
        return pulumi.get(self, "rescan_after_refresh")

    @property
    @pulumi.getter(name="setPermissionsLinux")
    def set_permissions_linux(self) -> pulumi.Output[bool]:
        """
        Set permission for imported files.
        """
        return pulumi.get(self, "set_permissions_linux")

    @property
    @pulumi.getter(name="skipFreeSpaceCheckWhenImporting")
    def skip_free_space_check_when_importing(self) -> pulumi.Output[bool]:
        """
        Skip free space check before importing.
        """
        return pulumi.get(self, "skip_free_space_check_when_importing")

