# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConfigArgs', 'Config']

@pulumi.input_type
class ConfigArgs:
    def __init__(__self__, *,
                 certification_country: pulumi.Input[str]):
        """
        The set of arguments for constructing a Config resource.
        :param pulumi.Input[str] certification_country: Certification Country.
        """
        pulumi.set(__self__, "certification_country", certification_country)

    @property
    @pulumi.getter(name="certificationCountry")
    def certification_country(self) -> pulumi.Input[str]:
        """
        Certification Country.
        """
        return pulumi.get(self, "certification_country")

    @certification_country.setter
    def certification_country(self, value: pulumi.Input[str]):
        pulumi.set(self, "certification_country", value)


@pulumi.input_type
class _ConfigState:
    def __init__(__self__, *,
                 certification_country: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Config resources.
        :param pulumi.Input[str] certification_country: Certification Country.
        """
        if certification_country is not None:
            pulumi.set(__self__, "certification_country", certification_country)

    @property
    @pulumi.getter(name="certificationCountry")
    def certification_country(self) -> Optional[pulumi.Input[str]]:
        """
        Certification Country.
        """
        return pulumi.get(self, "certification_country")

    @certification_country.setter
    def certification_country(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "certification_country", value)


class Config(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certification_country: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        <!-- subcategory:Metadata -->
        Metadata Config resource.
        For more information refer to [Metadata](https://wiki.servarr.com/radarr/settings#options) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_radarr as radarr

        example = radarr.metadata.Config("example", certification_country="us")
        ```

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import radarr:Metadata/config:Config example ""
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] certification_country: Certification Country.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Metadata -->
        Metadata Config resource.
        For more information refer to [Metadata](https://wiki.servarr.com/radarr/settings#options) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_radarr as radarr

        example = radarr.metadata.Config("example", certification_country="us")
        ```

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import radarr:Metadata/config:Config example ""
        ```

        :param str resource_name: The name of the resource.
        :param ConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certification_country: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConfigArgs.__new__(ConfigArgs)

            if certification_country is None and not opts.urn:
                raise TypeError("Missing required property 'certification_country'")
            __props__.__dict__["certification_country"] = certification_country
        super(Config, __self__).__init__(
            'radarr:Metadata/config:Config',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            certification_country: Optional[pulumi.Input[str]] = None) -> 'Config':
        """
        Get an existing Config resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] certification_country: Certification Country.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConfigState.__new__(_ConfigState)

        __props__.__dict__["certification_country"] = certification_country
        return Config(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="certificationCountry")
    def certification_country(self) -> pulumi.Output[str]:
        """
        Certification Country.
        """
        return pulumi.get(self, "certification_country")

